/*
  checksec.f 1bo߂ǂ`FbNTu[` by saibara Ver1.09
  
  vs_time (1.09ȍ~)
  
  Ver.1.00 watch.f Ver.2.03쐬
  Ver.1.01 half_sec(),msec()ǉ
  Ver.1.02 (2011/06/28) watch.f̋ʊ֐A񂩂̌checkl_secǉ
  Ver.1.03 (2011/07/20) s_watch.c 𗘗p`ɕύXB
  Ver.1.04 (2011/07/21) init_check_sec()ɃtOǉ(dlύX)
  Ver.1.05 (2011/10/12) \[XA[hǉAusecɓ(ʕbP)
  Ver.1.06 (2011/10/13) [h3(ԊuJƂ\郂[h)ǉ
  Ver.1.07 (2012/02/27) ԂloߕbɕύX
  Ver.1.08 (2012/09/11) cs_data\̂Ē`AƗ\ɂ
  Ver.1.09 (2012/09/12) s_timeƗɔs_watchˑ
  
  mode̎wl
  0 : init̎Ԃgp
  1 : check_secKuTRUEvɂA̎_̎Ԃ𗘗p
  2 : check_secKuFALSEvɂA̎_̎Ԃ𗘗p
  3 : {mode1ƓAc莞Ԃ̈kȂ
  4 : {mode2ƓAc莞Ԃ̈kȂ
  
  init_check_sec(mode);
  check_sec();
  check_half_sec();
  check_usec(unsigned long cswait);
  
  cs_data csd;
  
  cs_init(&csd,mode);
  cs_check_sec(&csd);
  cs_check_half_sec(&csd);
  cs_check_usec(&csd,unsigned long cswait);
  
  ӓ_
  watch.fƂ͊SɓƗBvs_watch
  w莞Ԃ̒Pʂ̓(}CN)bBʓ|ȂDIV_SW_WATCH_TIMEg
*/
#ifndef _CHECKSEC_F_
#define _CHECKSEC_F_

/* `FbNԊu(secP) */
#define CS_WAIT_TIME		1000000UL
#define CS_HALF_WAIT_TIME	 500000UL
#define CS_SECOND_TIME		   1000UL

#include <string.h>

#include "s_time.h"

typedef struct {
  s_time cs_time;	// vJn
  
  // ԃ`FbN[h(쒆)
  int cs_init_mode;
  // 0:v(checkAw莞Ԍo߂ĂTRUEԂAȊOFALSE)
  // 1:vOFcheckTRUEԂ̎_vJn
  // 2:vOFcheckFALSEԂ̎_vJn

  // c莞Ԃk邩Ȃ̃[h
  int cs_limit_mode;
  // 0:k(񈳏kԂ)
  // 1:kȂ
} cs_data;

// cs_̖checksecp̎ԍ\
static cs_data cs_checksec;

int cs_check_usec(cs_data *csd,unsigned long cswait)
{
  int count;
  unsigned long now_time;

  if(csd == NULL) csd = &cs_checksec;
  count = 0;
  
  switch(csd->cs_init_mode)
    {
    case 0: // ʏ
      now_time = st_get_now_time(&csd->cs_time);
      while(now_time > cswait)
	{
	  count++;
	  now_time -= cswait;
	  st_add_time(&(csd->cs_time),cswait);
	  if(csd->cs_limit_mode) return(count);
	}
      break;
    case 1: // TRUEԂ̂܂܌vJn
      count++;
    case 2: // FALSEԂ̂܂܌vJn
    default:
      csd->cs_init_mode = 0;
      st_get_time(&(csd->cs_time));
      break;
    }
  return(count);
}

void cs_init(cs_data *csd,int mode)
{
  if(csd == NULL) csd = &cs_checksec;

  // ݒ(mode=0̐ݒ)
  memset(csd,0,sizeof(cs_data));
  st_get_time(&(csd->cs_time));
  switch(mode)
    {
    case 1:
      csd->cs_init_mode = 1;
      break;
    case 2:
      csd->cs_init_mode = 2;
      break;
    case 3:
      csd->cs_init_mode = 1;
      csd->cs_limit_mode = 1;
      break;
    case 4:
      csd->cs_init_mode = 2;
      csd->cs_limit_mode = 1;
      break;
    }
}

#define cs_check_sec(csd)	cs_check_usec(csd,CS_WAIT_TIME)
#define cs_check_half_sec(csd)	cs_check_usec(csd,CS_HALF_WAIT_TIME)
#define cs_check_msec(csd,a)	cs_check_usec(csd,(a)*CS_SECOND_TIME)

#define check_usec(a)		cs_check_usec(NULL,a)
#define init_check_usec(mode)		cs_init(NULL,mode)

#define check_sec()		check_usec(CS_WAIT_TIME)
#define check_half_sec()	check_usec(CS_HALF_WAIT_TIME)
#define check_msec(a)		check_usec((a)*CS_SECOND_TIME)
#define init_check_sec(mode)		init_check_usec(mode)
#define init_check_half_sec(mode)	init_check_usec(mode)
#define init_check_msec(mode)		init_check_usec(mode)

/************************************************************************/
#endif // _CHECKSEC_F_
